diff --git a/core/unix/include/sigcontext.h b/core/unix/include/sigcontext.h
index 4551fab688..43ef10ae07 100644
--- a/core/unix/include/sigcontext.h
+++ b/core/unix/include/sigcontext.h
@@ -35,24 +35,30 @@
  * larger XSAVE areas.
  */
 typedef struct _kernel_fpx_sw_bytes_t {
-    __u32 magic1;        /* FP_XSTATE_MAGIC1 */
-    __u32 extended_size; /* Total size of the fpstate area:
-                          *
-                          * - if magic1 == 0 then it's sizeof(struct _fpstate)
-                          * - if magic1 == FP_XSTATE_MAGIC1 then it's sizeof(struct
-                          *   _xstate) plus extensions (if any)
-                          */
+    __u32 magic1; /* FP_XSTATE_MAGIC1 */
+    /* Total size of the fpstate area:
+     *
+     * - if magic1 == 0 then it's sizeof(struct _fpstate)
+     * - if magic1 == FP_XSTATE_MAGIC1 then it's sizeof(struct
+     *   _xstate) plus extensions (if any).
+     *
+     * The extensions always include FP_XSTATE_MAGIC2_SIZE.
+     * For 32-bit, they also include the FSAVE fields, but those are actually
+     * prepended: for DR they're the initial part of the 32-bit kernel_fpstate_t
+     * and thus part of kernel_xstate_t already.
+     */
+    __u32 extended_size;
     __u64 xstate_bv;
     /* feature bit mask (including fp/sse/extended
      * state) that is present in the memory
      * layout.
      */
-    __u32 xstate_size; /* actual xsave state size, based on the
-                        * features saved in the layout.
-                        * 'extended_size' will be greater than
-                        * 'xstate_size'.
-                        */
-    __u32 padding[7];  /*  for future use. */
+    /* Actual xsave state size, based on the features saved in the layout.
+     * 'extended_size' will be greater than 'xstate_size' (because it includes
+     * FP_XSTATE_MAGIC2, plus FSAVE data for 32-bit).
+     */
+    __u32 xstate_size;
+    __u32 padding[7]; /*  for future use. */
 } kernel_fpx_sw_bytes_t;
 
 #ifdef __i386__
@@ -86,7 +92,13 @@ typedef struct _kernel_xmmreg_t {
 } kernel_xmmreg_t;
 
 typedef struct _kernel_fpstate_t {
-    /* Regular FPU environment */
+    /* Regular FPU environment.
+     * These initial fields are the FSAVE format.  They are followed by the
+     * FXSAVE, which matches the 64-bit kernel_fpstate_t.  Note that in the kernel
+     * code, it treats this FSAVE prefix as a separate thing and includes it in
+     * extra size in kernel_fpx_sw_bytes_t.extended_size, although it is in essence
+     * prepended instead of appended.
+     */
     unsigned long cw;
     unsigned long sw;
     unsigned long tag;
diff --git a/core/unix/signal.c b/core/unix/signal.c
index 96c21d110e..5d2c06635d 100644
--- a/core/unix/signal.c
+++ b/core/unix/signal.c
@@ -3057,40 +3057,31 @@ fixup_rtframe_pointers(dcontext_t *dcontext, int sig, sigframe_rt_t *f_old,
         uint frame_size = get_app_frame_size(info, sig);
         byte *frame_end = ((byte *)f_new) + frame_size;
         byte *tgt = (byte *)ALIGN_FORWARD(frame_end, XSTATE_ALIGNMENT);
-        ASSERT(tgt - frame_end <= signal_frame_extra_size(true));
-        memcpy(tgt, f_old->uc.uc_mcontext.fpstate, sizeof(kernel_fpstate_t));
-        f_new->uc.uc_mcontext.fpstate = (kernel_fpstate_t *)tgt;
-        if (YMM_ENABLED()) {
-            kernel_xstate_t *xstate_new = (kernel_xstate_t *)tgt;
-            kernel_xstate_t *xstate_old =
-                (kernel_xstate_t *)f_old->uc.uc_mcontext.fpstate;
-            memcpy(&xstate_new->xstate_hdr, &xstate_old->xstate_hdr,
-                   sizeof(xstate_new->xstate_hdr));
-            memcpy(&xstate_new->ymmh, &xstate_old->ymmh, sizeof(xstate_new->ymmh));
-        }
-#    ifdef X64
-        if (ZMM_ENABLED()) {
-            kernel_xstate_t *xstate_new = (kernel_xstate_t *)tgt;
-            kernel_xstate_t *xstate_old =
-                (kernel_xstate_t *)f_old->uc.uc_mcontext.fpstate;
-            memcpy((byte *)xstate_new + proc_xstate_area_zmm_hi256_offs(),
-                   (byte *)xstate_old + proc_xstate_area_zmm_hi256_offs(),
-                   proc_num_simd_sse_avx_registers() * ZMMH_REG_SIZE);
-            memcpy((byte *)xstate_new + proc_xstate_area_hi16_zmm_offs(),
-                   (byte *)xstate_old + proc_xstate_area_hi16_zmm_offs(),
-                   (proc_num_simd_registers() - proc_num_simd_sse_avx_registers()) *
-                       ZMM_REG_SIZE);
-            memcpy((byte *)xstate_new + proc_xstate_area_kmask_offs(),
-                   (byte *)xstate_old + proc_xstate_area_kmask_offs(),
-                   proc_num_opmask_registers() * OPMASK_AVX512BW_REG_SIZE);
-        }
-#    else
-        /* FIXME i#1312: it is unclear if and how the components are arranged in
-         * 32-bit mode by the kernel.
+        size_t extra_size = signal_frame_extra_size(false);
+        ASSERT(extra_size == f_new->uc.uc_mcontext.fpstate->sw_reserved.extended_size);
+        /* XXX: It may be better to move this into memcpy_rt_frame (or another
+         * routine, since copy_frame_to_pending() wants them separate), since
+         * fixup_rtframe_pointers() was originally meant to just update a few
+         * pointers and not do a big memcpy.  Compare to MACOS which calls it in
+         * copy_frame_to_pending(): if Linux did that we'd have memory clobbering.
          */
-#    endif
+        memcpy(tgt, f_new->uc.uc_mcontext.fpstate, extra_size);
+        f_new->uc.uc_mcontext.fpstate = (kernel_fpstate_t *)tgt;
         LOG(THREAD, LOG_ASYNCH, level + 1, "\tfpstate old=" PFX " new=" PFX "\n",
             f_old->uc.uc_mcontext.fpstate, f_new->uc.uc_mcontext.fpstate);
+        /* Be sure we're keeping both magic words.  Failure to do so causes the
+         * kernel to only restore x87 and SSE state and zero out all AVX+ state
+         * (i#3812).
+         */
+        ASSERT(f_new->uc.uc_mcontext.fpstate->sw_reserved.magic1 ==
+               f_old->uc.uc_mcontext.fpstate->sw_reserved.magic1);
+        ASSERT((f_new->uc.uc_mcontext.fpstate->sw_reserved.magic1 == 0 &&
+                f_new->uc.uc_mcontext.fpstate->sw_reserved.extended_size ==
+                    sizeof(kernel_fpstate_t)) ||
+               (f_new->uc.uc_mcontext.fpstate->sw_reserved.magic1 == FP_XSTATE_MAGIC1 &&
+                *(int *)((byte *)f_new->uc.uc_mcontext.fpstate +
+                         f_new->uc.uc_mcontext.fpstate->sw_reserved.extended_size -
+                         FP_XSTATE_MAGIC2_SIZE) == FP_XSTATE_MAGIC2));
     } else {
         /* if fpstate is not set up, we're delivering signal immediately,
          * and we shouldn't need an fpstate since DR code won't modify it;
@@ -3339,9 +3330,9 @@ copy_frame_to_pending(dcontext_t *dcontext, int sig,
      * copy now in case our own retrieval somehow misses some fields
      */
     if (frame->uc.uc_mcontext.fpstate != NULL) {
-        memcpy(&info->sigpending[sig]->xstate, frame->uc.uc_mcontext.fpstate,
-               /* XXX: assuming full xstate if avx is enabled */
-               signal_frame_extra_size(false));
+        size_t extra_size = signal_frame_extra_size(false);
+        ASSERT(extra_size == frame->uc.uc_mcontext.fpstate->sw_reserved.extended_size);
+        memcpy(&info->sigpending[sig]->xstate, frame->uc.uc_mcontext.fpstate, extra_size);
     }
     /* we must set the pointer now so that later save_fpstate, etc. work */
     dst->uc.uc_mcontext.fpstate = (kernel_fpstate_t *)&info->sigpending[sig]->xstate;
@@ -6123,6 +6114,12 @@ handle_sigreturn(dcontext_t *dcontext, void *ucxt_param, int style)
 #    endif
         sc = get_sigcontext_from_app_frame(info, sig, (void *)frame);
         ucxt = &frame->uc;
+        /* Check again for the magic words. See the i#3812 comment above. */
+        ASSERT((sc->fpstate->sw_reserved.magic1 == 0 &&
+                sc->fpstate->sw_reserved.extended_size == sizeof(kernel_fpstate_t)) ||
+               (sc->fpstate->sw_reserved.magic1 == FP_XSTATE_MAGIC1 &&
+                *(int *)((byte *)sc->fpstate + sc->fpstate->sw_reserved.extended_size -
+                         FP_XSTATE_MAGIC2_SIZE) == FP_XSTATE_MAGIC2));
 #elif defined(MACOS)
         /* The initial frame fields on the stack are messed up due to
          * params to handler from tramp, so use params to syscall.
@@ -6414,6 +6411,20 @@ os_forge_exception(app_pc target_pc, dr_exception_type_t type)
 #if defined(LINUX) && defined(X86)
     /* We use a TLS buffer to avoid too much stack space here. */
     sc->fpstate = (kernel_fpstate_t *)get_xstate_buffer(dcontext);
+    sc->fpstate->sw_reserved.extended_size = signal_frame_extra_size(false);
+    if (YMM_ENABLED()) {
+        sc->fpstate->sw_reserved.magic1 = FP_XSTATE_MAGIC1;
+        sc->fpstate->sw_reserved.xstate_size = sizeof(kernel_xstate_t);
+        uint bv_high, bv_low;
+        dr_xgetbv(&bv_high, &bv_low);
+        sc->fpstate->sw_reserved.xstate_bv = (((uint64)bv_high) << 32) | bv_low;
+        *(int *)((byte *)sc->fpstate + sc->fpstate->sw_reserved.extended_size -
+                 FP_XSTATE_MAGIC2_SIZE) = FP_XSTATE_MAGIC2;
+    } else {
+        sc->fpstate->sw_reserved.magic1 = 0;
+        sc->fpstate->sw_reserved.xstate_size = sizeof(kernel_fpstate_t);
+        sc->fpstate->sw_reserved.xstate_bv = 0;
+    }
 #endif
     mcontext_to_ucontext(uc, get_mcontext(dcontext));
     sc->SC_XIP = (reg_t)target_pc;
diff --git a/core/unix/signal_linux_x86.c b/core/unix/signal_linux_x86.c
index 2f6c1efd42..cdc0afb69d 100644
--- a/core/unix/signal_linux_x86.c
+++ b/core/unix/signal_linux_x86.c
@@ -203,11 +203,11 @@ save_xmm(dcontext_t *dcontext, sigframe_rt_t *frame)
         /* Fill in the extra fields first and then clobber xmm+ymm below.
          * We assume that DR's code does not touch this extra state.
          */
-        ASSERT(ALIGNED(xstate, AVX_ALIGNMENT));
         /* A processor w/o xsave but w/ extra xstate fields should not exist. */
         ASSERT(proc_has_feature(FEATURE_XSAVE));
         /* XXX i#1312: use xsaveopt if available (need to add FEATURE_XSAVEOPT) */
 #ifdef X64
+        ASSERT(ALIGNED(xstate, AVX_ALIGNMENT));
         /* Some assemblers, including on Travis, don't know "xsave64", so we
          * have to use raw bytes for:
          *    48 0f ae 21  xsave64 (%rcx)
@@ -225,12 +225,24 @@ save_xmm(dcontext_t *dcontext, sigframe_rt_t *frame)
                      : "m"(xstate)
                      : "eax", "edx", "rcx", "memory");
 #else
+#    if DISABLED_ISSUE_3256
+        /* FIXME i#3256: DR's kernel_fpstate_t includes the fsave 0x70 bytes at the
+         * top.  We need to skip them to reach the xsave area at the _fxsr_env field.
+         * However, that requires aligning that instead of the kernel_fpstate_t start
+         * itself in sigpending_t and the frame we make on the app stack.  An
+         * alternative here is to copy into a temp buffer but that seems wasteful.
+         * For now we skip the xsave, which seems safer than clobbering the wrong
+         * fields, but is also buggy and can cause app data corruption.
+         */
+        byte *xsave_start = (byte *)(&xstate->fpstate._fxsr_env[0]);
+        ASSERT(ALIGNED(xsave_start, AVX_ALIGNMENT));
         /* We only enable the x87 state component. The rest of the user state components
          * gets copied below from priv_mcontext_t.
          * FIXME i#1312: it is unclear if and how the components are arranged in
          * 32-bit mode by the kernel. In fact, if we enable more state components here
          * than this, we get a crash in linux.sigcontext. This needs clarification about
          * what the kernel does for 32-bit with the extended xsave area.
+         * UPDATE from i#3256 analysis: Was this due to the incorrect xsave target?
          */
         asm volatile("mov $0x0, %%edx\n\t"
                      "mov $0x1, %%eax\n\t"
@@ -239,8 +251,9 @@ save_xmm(dcontext_t *dcontext, sigframe_rt_t *frame)
                      ".byte 0xae\n\t"
                      ".byte 0x21\n"
                      :
-                     : "m"(xstate)
+                     : "m"(xsave_start)
                      : "eax", "edx", "ecx", "memory");
+#    endif
 #endif
     }
     if (YMM_ENABLED()) {
@@ -669,7 +682,7 @@ xstate_query_signal_handler(int sig, kernel_siginfo_t *siginfo, kernel_ucontext_
 void
 signal_arch_init(void)
 {
-    xstate_size = sizeof(kernel_xstate_t) + 4 /* trailing FP_XSTATE_MAGIC2 */;
+    xstate_size = sizeof(kernel_xstate_t) + FP_XSTATE_MAGIC2_SIZE;
     ASSERT(YMM_ENABLED() || !ZMM_ENABLED());
     if (YMM_ENABLED() && !standalone_library /* avoid SIGILL for standalone */) {
         kernel_sigaction_t act, oldact;
diff --git a/suite/tests/CMakeLists.txt b/suite/tests/CMakeLists.txt
index 7fbc595214..8d679ba7d6 100644
--- a/suite/tests/CMakeLists.txt
+++ b/suite/tests/CMakeLists.txt
@@ -2421,6 +2421,13 @@ if (CLIENT_INTERFACE)
       target_include_directories(api.detach_state PRIVATE
         ${CMAKE_CURRENT_SOURCE_DIR}/api)
       link_with_pthread(api.detach_state)
+      if (proc_supports_avx512)
+        append_property_string(TARGET api.detach_state COMPILE_FLAGS "${CFLAGS_AVX512}")
+        set(api.detach_state_runavx512 1)
+      elseif (proc_supports_avx)
+        append_property_string(TARGET api.detach_state COMPILE_FLAGS "${CFLAGS_AVX}")
+        set(api.detach_state_runavx 1)
+      endif ()
     endif ()
     if (NOT WIN32) # XXX i#2611: fix for Windows
       if (X64)
@@ -2613,6 +2620,8 @@ endif ()
       # XXX i#1312: we do not yet support AVX-512 Windows context switching.
       tobuild_ci(client.avx512ctx client-interface/avx512ctx.c "" "" "")
       set_target_properties(client.avx512ctx PROPERTIES COMPILE_FLAGS "${CFLAGS_AVX512}")
+      append_property_string(TARGET client.avx512ctx.dll COMPILE_FLAGS
+        "${CFLAGS_AVX512}")
       target_include_directories(client.avx512ctx PRIVATE
         ${CMAKE_CURRENT_SOURCE_DIR}/client-interface)
 
diff --git a/suite/tests/api/detach_state.c b/suite/tests/api/detach_state.c
index 6bd570081d..d8a5fd5f8f 100644
--- a/suite/tests/api/detach_state.c
+++ b/suite/tests/api/detach_state.c
@@ -1,5 +1,5 @@
 /* **********************************************************
- * Copyright (c) 2018 Google, Inc.  All rights reserved.
+ * Copyright (c) 2018-2019 Google, Inc.  All rights reserved.
  * **********************************************************/
 
 /*
@@ -224,11 +224,13 @@ check_gpr_value(const char *name, ptr_uint_t value, ptr_uint_t expect)
 }
 
 static void
-check_xmm_value(const char *name, ptr_uint_t value, ptr_uint_t expect)
+check_simd_value(const char *prefix, int idx, const char *suffix, ptr_uint_t value,
+                 ptr_uint_t expect)
 {
-    VPRINT("Value of %s is 0x%lx; expect 0x%lx\n", name, value, expect);
-    if (value != expect)
-        print("ERROR: detach changed %s from 0x%lx to 0x%lx\n", name, expect, value);
+    char name[16];
+    int len = snprintf(name, BUFFER_SIZE_ELEMENTS(name), "%s%d.%s", prefix, idx, suffix);
+    assert(len > 0 && len < BUFFER_SIZE_ELEMENTS(name));
+    check_gpr_value(name, value, expect);
 }
 
 /* If selfmod is true, allows xax and xcx to not match (selfmod code had to
@@ -237,39 +239,55 @@ check_xmm_value(const char *name, ptr_uint_t value, ptr_uint_t expect)
 void
 check_gpr_vals(ptr_uint_t *xsp, bool selfmod)
 {
+    int i;
 #    ifdef X64
-    check_gpr_value("xmm0.hi", *(xsp + 17), MAKE_HEX_C(XMM0_HIGH_BASE()));
-    check_gpr_value("xmm0.lo", *(xsp + 16), MAKE_HEX_C(XMM0_LOW_BASE()));
-    check_gpr_value("xmm1.hi", *(xsp + 19), MAKE_HEX_C(XMM1_HIGH_BASE()));
-    check_gpr_value("xmm1.lo", *(xsp + 18), MAKE_HEX_C(XMM1_LOW_BASE()));
-    check_gpr_value("xmm2.hi", *(xsp + 21), MAKE_HEX_C(XMM2_HIGH_BASE()));
-    check_gpr_value("xmm2.lo", *(xsp + 20), MAKE_HEX_C(XMM2_LOW_BASE()));
-    check_gpr_value("xmm3.hi", *(xsp + 23), MAKE_HEX_C(XMM3_HIGH_BASE()));
-    check_gpr_value("xmm3.lo", *(xsp + 22), MAKE_HEX_C(XMM3_LOW_BASE()));
-    check_gpr_value("xmm4.hi", *(xsp + 25), MAKE_HEX_C(XMM4_HIGH_BASE()));
-    check_gpr_value("xmm4.lo", *(xsp + 24), MAKE_HEX_C(XMM4_LOW_BASE()));
-    check_gpr_value("xmm5.hi", *(xsp + 27), MAKE_HEX_C(XMM5_HIGH_BASE()));
-    check_gpr_value("xmm5.lo", *(xsp + 26), MAKE_HEX_C(XMM5_LOW_BASE()));
-    check_gpr_value("xmm6.hi", *(xsp + 29), MAKE_HEX_C(XMM6_HIGH_BASE()));
-    check_gpr_value("xmm6.lo", *(xsp + 28), MAKE_HEX_C(XMM6_LOW_BASE()));
-    check_gpr_value("xmm7.hi", *(xsp + 31), MAKE_HEX_C(XMM7_HIGH_BASE()));
-    check_gpr_value("xmm7.lo", *(xsp + 30), MAKE_HEX_C(XMM7_LOW_BASE()));
-    check_gpr_value("xmm8.hi", *(xsp + 33), MAKE_HEX_C(XMM8_HIGH_BASE()));
-    check_gpr_value("xmm8.lo", *(xsp + 32), MAKE_HEX_C(XMM8_LOW_BASE()));
-    check_gpr_value("xmm9.hi", *(xsp + 35), MAKE_HEX_C(XMM9_HIGH_BASE()));
-    check_gpr_value("xmm9.lo", *(xsp + 34), MAKE_HEX_C(XMM9_LOW_BASE()));
-    check_gpr_value("xmm10.hi", *(xsp + 37), MAKE_HEX_C(XMM10_HIGH_BASE()));
-    check_gpr_value("xmm10.lo", *(xsp + 36), MAKE_HEX_C(XMM10_LOW_BASE()));
-    check_gpr_value("xmm11.hi", *(xsp + 39), MAKE_HEX_C(XMM11_HIGH_BASE()));
-    check_gpr_value("xmm11.lo", *(xsp + 38), MAKE_HEX_C(XMM11_LOW_BASE()));
-    check_gpr_value("xmm12.hi", *(xsp + 41), MAKE_HEX_C(XMM12_HIGH_BASE()));
-    check_gpr_value("xmm12.lo", *(xsp + 40), MAKE_HEX_C(XMM12_LOW_BASE()));
-    check_gpr_value("xmm13.hi", *(xsp + 43), MAKE_HEX_C(XMM13_HIGH_BASE()));
-    check_gpr_value("xmm13.lo", *(xsp + 42), MAKE_HEX_C(XMM13_LOW_BASE()));
-    check_gpr_value("xmm14.hi", *(xsp + 45), MAKE_HEX_C(XMM14_HIGH_BASE()));
-    check_gpr_value("xmm14.lo", *(xsp + 44), MAKE_HEX_C(XMM14_LOW_BASE()));
-    check_gpr_value("xmm15.hi", *(xsp + 47), MAKE_HEX_C(XMM15_HIGH_BASE()));
-    check_gpr_value("xmm15.lo", *(xsp + 46), MAKE_HEX_C(XMM15_LOW_BASE()));
+#        define NUM_GPRS 16
+#        define SIMD_SZ_IN_PTRS (SIMD_REG_SIZE / sizeof(ptr_uint_t))
+#        ifdef __AVX512F__
+    for (i = 0; i < NUM_SIMD_REGS; i++) {
+        check_simd_value("xmm", i, "lo", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 0),
+                         MAKE_HEX_C(XMM0_LOW_BASE()) << i);
+        check_simd_value("xmm", i, "hi", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 1),
+                         MAKE_HEX_C(XMM0_HIGH_BASE()) << i);
+        check_simd_value("ymmh", i, "lo", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 2),
+                         MAKE_HEX_C(YMMH0_LOW_BASE()) << i);
+        check_simd_value("ymmh", i, "hi", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 3),
+                         MAKE_HEX_C(YMMH0_HIGH_BASE()) << i);
+        check_simd_value("zmmh", i, "0", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 4),
+                         MAKE_HEX_C(ZMMH0_0_BASE()) << i);
+        check_simd_value("zmmh", i, "1", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 5),
+                         MAKE_HEX_C(ZMMH0_1_BASE()) << i);
+        check_simd_value("zmmh", i, "2", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 6),
+                         MAKE_HEX_C(ZMMH0_2_BASE()) << i);
+        check_simd_value("zmmh", i, "3", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 7),
+                         MAKE_HEX_C(ZMMH0_3_BASE()) << i);
+    }
+    assert(sizeof(unsigned short) == OPMASK_REG_SIZE);
+    unsigned short *kbase = (unsigned short *)(xsp + NUM_GPRS + NUM_SIMD_REGS * 8);
+    for (i = 0; i < NUM_OPMASK_REGS; i++) {
+        ptr_uint_t val = *(kbase + i);
+        check_simd_value("k", i, "", val,
+                         (unsigned short)(MAKE_HEX_C(OPMASK0_BASE()) << i));
+    }
+#        elif defined(__AVX__)
+    for (i = 0; i < NUM_SIMD_REGS; i++) {
+        check_simd_value("xmm", i, "lo", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 0),
+                         MAKE_HEX_C(XMM0_LOW_BASE()) << i);
+        check_simd_value("xmm", i, "hi", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 1),
+                         MAKE_HEX_C(XMM0_HIGH_BASE()) << i);
+        check_simd_value("ymmh", i, "lo", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 2),
+                         MAKE_HEX_C(YMMH0_LOW_BASE()) << i);
+        check_simd_value("ymmh", i, "hi", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 3),
+                         MAKE_HEX_C(YMMH0_HIGH_BASE()) << i);
+    }
+#        else
+    for (i = 0; i < NUM_SIMD_REGS; i++) {
+        check_simd_value("xmm", i, "lo", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 0),
+                         MAKE_HEX_C(XMM0_LOW_BASE()) << i);
+        check_simd_value("xmm", i, "hi", *(xsp + NUM_GPRS + i * SIMD_SZ_IN_PTRS + 1),
+                         MAKE_HEX_C(XMM0_HIGH_BASE()) << i);
+    }
+#        endif
     check_gpr_value("r15", *(xsp + 15), MAKE_HEX_C(R15_BASE()));
     check_gpr_value("r14", *(xsp + 14), MAKE_HEX_C(R14_BASE()));
     check_gpr_value("r13", *(xsp + 13), MAKE_HEX_C(R13_BASE()));
@@ -372,25 +390,7 @@ main(void)
 START_FILE
 
 #    ifdef X64
-/* This does NOT make xsp have its pre-push value. */
-#        define PUSHALL \
-        lea      rsp, [rsp - 16*16] @N@ \
-        movups   [rsp +  0*16], xmm0 @N@ \
-        movups   [rsp +  1*16], xmm1 @N@ \
-        movups   [rsp +  2*16], xmm2 @N@ \
-        movups   [rsp +  3*16], xmm3 @N@ \
-        movups   [rsp +  4*16], xmm4 @N@ \
-        movups   [rsp +  5*16], xmm5 @N@ \
-        movups   [rsp +  6*16], xmm6 @N@ \
-        movups   [rsp +  7*16], xmm7 @N@ \
-        movups   [rsp +  8*16], xmm8 @N@ \
-        movups   [rsp +  9*16], xmm9 @N@ \
-        movups   [rsp + 10*16], xmm10 @N@ \
-        movups   [rsp + 11*16], xmm11 @N@ \
-        movups   [rsp + 12*16], xmm12 @N@ \
-        movups   [rsp + 13*16], xmm13 @N@ \
-        movups   [rsp + 14*16], xmm14 @N@ \
-        movups   [rsp + 15*16], xmm15 @N@ \
+#        define PUSH_GPRS \
         push     r15 @N@\
         push     r14 @N@\
         push     r13 @N@\
@@ -408,7 +408,94 @@ START_FILE
         push     rbp @N@\
         push     rsi @N@\
         push     rdi
-#        define POPALL        \
+/* This does NOT make xsp have its pre-push value. */
+#        ifdef __AVX512F__
+#            define PUSHALL                 \
+        lea      rsp, [rsp - NUM_SIMD_REGS*SIMD_REG_SIZE - \
+                       NUM_OPMASK_REGS*OPMASK_REG_SIZE] @N@     \
+        vmovups  [rsp +  0*SIMD_REG_SIZE], zmm0 @N@ \
+        vmovups  [rsp +  1*SIMD_REG_SIZE], zmm1 @N@ \
+        vmovups  [rsp +  2*SIMD_REG_SIZE], zmm2 @N@ \
+        vmovups  [rsp +  3*SIMD_REG_SIZE], zmm3 @N@ \
+        vmovups  [rsp +  4*SIMD_REG_SIZE], zmm4 @N@ \
+        vmovups  [rsp +  5*SIMD_REG_SIZE], zmm5 @N@ \
+        vmovups  [rsp +  6*SIMD_REG_SIZE], zmm6 @N@ \
+        vmovups  [rsp +  7*SIMD_REG_SIZE], zmm7 @N@ \
+        vmovups  [rsp +  8*SIMD_REG_SIZE], zmm8 @N@ \
+        vmovups  [rsp +  9*SIMD_REG_SIZE], zmm9 @N@ \
+        vmovups  [rsp + 10*SIMD_REG_SIZE], zmm10 @N@ \
+        vmovups  [rsp + 11*SIMD_REG_SIZE], zmm11 @N@ \
+        vmovups  [rsp + 12*SIMD_REG_SIZE], zmm12 @N@ \
+        vmovups  [rsp + 13*SIMD_REG_SIZE], zmm13 @N@ \
+        vmovups  [rsp + 14*SIMD_REG_SIZE], zmm14 @N@ \
+        vmovups  [rsp + 15*SIMD_REG_SIZE], zmm15 @N@ \
+        vmovups  [rsp + 16*SIMD_REG_SIZE], zmm16 @N@ \
+        vmovups  [rsp + 17*SIMD_REG_SIZE], zmm17 @N@ \
+        vmovups  [rsp + 18*SIMD_REG_SIZE], zmm18 @N@ \
+        vmovups  [rsp + 19*SIMD_REG_SIZE], zmm19 @N@ \
+        vmovups  [rsp + 20*SIMD_REG_SIZE], zmm20 @N@ \
+        vmovups  [rsp + 21*SIMD_REG_SIZE], zmm21 @N@ \
+        vmovups  [rsp + 22*SIMD_REG_SIZE], zmm22 @N@ \
+        vmovups  [rsp + 23*SIMD_REG_SIZE], zmm23 @N@ \
+        vmovups  [rsp + 24*SIMD_REG_SIZE], zmm24 @N@ \
+        vmovups  [rsp + 25*SIMD_REG_SIZE], zmm25 @N@ \
+        vmovups  [rsp + 26*SIMD_REG_SIZE], zmm26 @N@ \
+        vmovups  [rsp + 27*SIMD_REG_SIZE], zmm27 @N@ \
+        vmovups  [rsp + 28*SIMD_REG_SIZE], zmm28 @N@ \
+        vmovups  [rsp + 29*SIMD_REG_SIZE], zmm29 @N@ \
+        vmovups  [rsp + 30*SIMD_REG_SIZE], zmm30 @N@ \
+        vmovups  [rsp + 31*SIMD_REG_SIZE], zmm31 @N@ \
+        kmovw    [rsp + NUM_SIMD_REGS*SIMD_REG_SIZE + 0*OPMASK_REG_SIZE], k0 @N@ \
+        kmovw    [rsp + NUM_SIMD_REGS*SIMD_REG_SIZE + 1*OPMASK_REG_SIZE], k1 @N@ \
+        kmovw    [rsp + NUM_SIMD_REGS*SIMD_REG_SIZE + 2*OPMASK_REG_SIZE], k2 @N@ \
+        kmovw    [rsp + NUM_SIMD_REGS*SIMD_REG_SIZE + 3*OPMASK_REG_SIZE], k3 @N@ \
+        kmovw    [rsp + NUM_SIMD_REGS*SIMD_REG_SIZE + 4*OPMASK_REG_SIZE], k4 @N@ \
+        kmovw    [rsp + NUM_SIMD_REGS*SIMD_REG_SIZE + 5*OPMASK_REG_SIZE], k5 @N@ \
+        kmovw    [rsp + NUM_SIMD_REGS*SIMD_REG_SIZE + 6*OPMASK_REG_SIZE], k6 @N@ \
+        kmovw    [rsp + NUM_SIMD_REGS*SIMD_REG_SIZE + 7*OPMASK_REG_SIZE], k7 @N@ \
+        PUSH_GPRS
+#        elif defined(__AVX__)
+#            define PUSHALL                 \
+        lea      rsp, [rsp - NUM_SIMD_REGS*SIMD_REG_SIZE] @N@ \
+        vmovdqu  [rsp +  0*SIMD_REG_SIZE], ymm0 @N@ \
+        vmovdqu  [rsp +  1*SIMD_REG_SIZE], ymm1 @N@ \
+        vmovdqu  [rsp +  2*SIMD_REG_SIZE], ymm2 @N@ \
+        vmovdqu  [rsp +  3*SIMD_REG_SIZE], ymm3 @N@ \
+        vmovdqu  [rsp +  4*SIMD_REG_SIZE], ymm4 @N@ \
+        vmovdqu  [rsp +  5*SIMD_REG_SIZE], ymm5 @N@ \
+        vmovdqu  [rsp +  6*SIMD_REG_SIZE], ymm6 @N@ \
+        vmovdqu  [rsp +  7*SIMD_REG_SIZE], ymm7 @N@ \
+        vmovdqu  [rsp +  8*SIMD_REG_SIZE], ymm8 @N@ \
+        vmovdqu  [rsp +  9*SIMD_REG_SIZE], ymm9 @N@ \
+        vmovdqu  [rsp + 10*SIMD_REG_SIZE], ymm10 @N@ \
+        vmovdqu  [rsp + 11*SIMD_REG_SIZE], ymm11 @N@ \
+        vmovdqu  [rsp + 12*SIMD_REG_SIZE], ymm12 @N@ \
+        vmovdqu  [rsp + 13*SIMD_REG_SIZE], ymm13 @N@ \
+        vmovdqu  [rsp + 14*SIMD_REG_SIZE], ymm14 @N@ \
+        vmovdqu  [rsp + 15*SIMD_REG_SIZE], ymm15 @N@ \
+        PUSH_GPRS
+#        else
+#            define PUSHALL                 \
+        lea      rsp, [rsp - NUM_SIMD_REGS*SIMD_REG_SIZE] @N@ \
+        movups   [rsp +  0*SIMD_REG_SIZE], xmm0 @N@ \
+        movups   [rsp +  1*SIMD_REG_SIZE], xmm1 @N@ \
+        movups   [rsp +  2*SIMD_REG_SIZE], xmm2 @N@ \
+        movups   [rsp +  3*SIMD_REG_SIZE], xmm3 @N@ \
+        movups   [rsp +  4*SIMD_REG_SIZE], xmm4 @N@ \
+        movups   [rsp +  5*SIMD_REG_SIZE], xmm5 @N@ \
+        movups   [rsp +  6*SIMD_REG_SIZE], xmm6 @N@ \
+        movups   [rsp +  7*SIMD_REG_SIZE], xmm7 @N@ \
+        movups   [rsp +  8*SIMD_REG_SIZE], xmm8 @N@ \
+        movups   [rsp +  9*SIMD_REG_SIZE], xmm9 @N@ \
+        movups   [rsp + 10*SIMD_REG_SIZE], xmm10 @N@ \
+        movups   [rsp + 11*SIMD_REG_SIZE], xmm11 @N@ \
+        movups   [rsp + 12*SIMD_REG_SIZE], xmm12 @N@ \
+        movups   [rsp + 13*SIMD_REG_SIZE], xmm13 @N@ \
+        movups   [rsp + 14*SIMD_REG_SIZE], xmm14 @N@ \
+        movups   [rsp + 15*SIMD_REG_SIZE], xmm15 @N@ \
+        PUSH_GPRS
+#        endif
+#    define POPALL        \
         pop      rdi @N@\
         pop      rsi @N@\
         pop      rbp @N@\
@@ -425,12 +512,46 @@ START_FILE
         pop      r13 @N@\
         pop      r14 @N@\
         pop      r15 @N@\
-        lea      rsp, [rsp + 16*16] @N@
+        lea      rsp, [rsp + NUM_SIMD_REGS*SIMD_REG_SIZE + \
+                       NUM_OPMASK_REGS*OPMASK_REG_SIZE] @N@
+#    ifdef __AVX512F__
+/* There seems to be no way to move our immeds into zmm using just rax
+ * and zmm##num, since the top part beyond xmm##num is zeroed.
+ * We use memory instead.
+ */
+#        define PUSH_IMMED(immed, num) \
+        mov      rax, MAKE_HEX_ASM(immed) @N@ \
+        shl      rax, num @N@ \
+        push     rax @N@
+#        define SET_ZMM_IMMED(num, xmm_low, xmm_high, ymmh_low, ymmh_high, \
+                              zmmh0, zmmh1, zmmh2, zmmh3) \
+        PUSH_IMMED(zmmh3, num) @N@ \
+        PUSH_IMMED(zmmh2, num) @N@ \
+        PUSH_IMMED(zmmh1, num) @N@ \
+        PUSH_IMMED(zmmh0, num) @N@ \
+        PUSH_IMMED(ymmh_high, num) @N@ \
+        PUSH_IMMED(ymmh_low, num) @N@ \
+        PUSH_IMMED(xmm_high, num) @N@ \
+        PUSH_IMMED(xmm_low, num) @N@ \
+        vmovups  zmm##num, [rsp] @N@       \
+        lea      rsp, [rsp + SIMD_REG_SIZE] @N@
+#        define SET_OPMASK_IMMED(num, immed) \
+        mov      rax, MAKE_HEX_ASM(immed) @N@ \
+        shl      rax, num @N@ \
+        kmovw    k##num, eax
+#    else
 #        define SET_XMM_IMMED(num, low_base, high_base)  \
         mov      rax, MAKE_HEX_ASM(low_base) @N@ \
+        shl      rax, num @N@ \
         movq     xmm##num, rax @N@ \
         mov      rax, MAKE_HEX_ASM(high_base) @N@ \
+        shl      rax, num @N@ \
         pinsrq   xmm##num, rax, 1 @N@
+#        define SET_YMM_IMMED(num, xmm_low, xmm_high, ymmh_low, ymmh_high) \
+        SET_XMM_IMMED(num, ymmh_low, ymmh_high) @N@ \
+        vinserti128 ymm##num, ymm##num, xmm##num, 1 @N@ \
+        SET_XMM_IMMED(num, xmm_low, xmm_high)
+#    endif
 #        define PUSH_CALLEE_SAVED \
         push     REG_XBP @N@ \
         push     REG_XBX @N@ \
@@ -462,22 +583,106 @@ DECL_EXTERN(safe_stack)
 #define FUNCNAME unique_values_to_registers
         DECLARE_FUNC(FUNCNAME)
 GLOBAL_LABEL(FUNCNAME:)
+#ifdef __AVX512F__
+#    define Z0 XMM0_LOW_BASE()
+#    define Z1 XMM0_HIGH_BASE()
+#    define Z2 YMMH0_LOW_BASE()
+#    define Z3 YMMH0_HIGH_BASE()
+#    define Z4 ZMMH0_0_BASE()
+#    define Z5 ZMMH0_1_BASE()
+#    define Z6 ZMMH0_2_BASE()
+#    define Z7 ZMMH0_3_BASE()
+        SET_ZMM_IMMED(0, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(1, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(2, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(3, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(4, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(5, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(6, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(7, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(8, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(9, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(10, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(11, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(12, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(13, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(14, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(15, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(16, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(17, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(18, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(19, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(20, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(21, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(22, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(23, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(24, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(25, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(26, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(27, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(28, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(29, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(30, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+        SET_ZMM_IMMED(31, Z0, Z1, Z2, Z3, Z4, Z5, Z6, Z7)
+#    undef Z0
+#    undef Z1
+#    undef Z2
+#    undef Z3
+#    undef Z4
+#    undef Z5
+#    undef Z6
+#    undef Z7
+        SET_OPMASK_IMMED(0, OPMASK0_BASE())
+        SET_OPMASK_IMMED(1, OPMASK0_BASE())
+        SET_OPMASK_IMMED(2, OPMASK0_BASE())
+        SET_OPMASK_IMMED(3, OPMASK0_BASE())
+        SET_OPMASK_IMMED(4, OPMASK0_BASE())
+        SET_OPMASK_IMMED(5, OPMASK0_BASE())
+        SET_OPMASK_IMMED(6, OPMASK0_BASE())
+        SET_OPMASK_IMMED(7, OPMASK0_BASE())
+#elif defined (__AVX__)
+#    define Y0 XMM0_LOW_BASE()
+#    define Y1 XMM0_HIGH_BASE()
+#    define Y2 YMMH0_LOW_BASE()
+#    define Y3 YMMH0_HIGH_BASE()
+        SET_YMM_IMMED(0, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(1, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(2, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(3, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(4, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(5, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(6, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(7, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(8, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(9, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(10, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(11, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(12, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(13, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(14, Y0, Y1, Y2, Y3)
+        SET_YMM_IMMED(15, Y0, Y1, Y2, Y3)
+#    undef Y0
+#    undef Y1
+#    undef Y2
+#    undef Y3
+#else
         SET_XMM_IMMED(0, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
-        SET_XMM_IMMED(1, XMM1_LOW_BASE(), XMM1_HIGH_BASE())
-        SET_XMM_IMMED(2, XMM2_LOW_BASE(), XMM2_HIGH_BASE())
-        SET_XMM_IMMED(3, XMM3_LOW_BASE(), XMM3_HIGH_BASE())
-        SET_XMM_IMMED(4, XMM4_LOW_BASE(), XMM4_HIGH_BASE())
-        SET_XMM_IMMED(5, XMM5_LOW_BASE(), XMM5_HIGH_BASE())
-        SET_XMM_IMMED(6, XMM6_LOW_BASE(), XMM6_HIGH_BASE())
-        SET_XMM_IMMED(7, XMM7_LOW_BASE(), XMM7_HIGH_BASE())
-        SET_XMM_IMMED(8, XMM8_LOW_BASE(), XMM8_HIGH_BASE())
-        SET_XMM_IMMED(9, XMM9_LOW_BASE(), XMM9_HIGH_BASE())
-        SET_XMM_IMMED(10, XMM10_LOW_BASE(), XMM10_HIGH_BASE())
-        SET_XMM_IMMED(11, XMM11_LOW_BASE(), XMM11_HIGH_BASE())
-        SET_XMM_IMMED(12, XMM12_LOW_BASE(), XMM12_HIGH_BASE())
-        SET_XMM_IMMED(13, XMM13_LOW_BASE(), XMM13_HIGH_BASE())
-        SET_XMM_IMMED(14, XMM14_LOW_BASE(), XMM14_HIGH_BASE())
-        SET_XMM_IMMED(15, XMM15_LOW_BASE(), XMM15_HIGH_BASE())
+        SET_XMM_IMMED(1, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(2, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(3, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(4, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(5, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(6, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(7, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(8, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(9, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(10, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(11, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(12, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(13, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(14, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+        SET_XMM_IMMED(15, XMM0_LOW_BASE(), XMM0_HIGH_BASE())
+#endif
 #ifdef X64
         mov      r15, MAKE_HEX_ASM(R15_BASE())
         mov      r14, MAKE_HEX_ASM(R14_BASE())
diff --git a/suite/tests/api/detach_state_shared.h b/suite/tests/api/detach_state_shared.h
index fd2be6c79d..754b03b6a6 100644
--- a/suite/tests/api/detach_state_shared.h
+++ b/suite/tests/api/detach_state_shared.h
@@ -1,5 +1,5 @@
 /* **********************************************************
- * Copyright (c) 2015-2018 Google, Inc.  All rights reserved.
+ * Copyright (c) 2015-2019 Google, Inc.  All rights reserved.
  * **********************************************************/
 
 /*
@@ -37,6 +37,36 @@
 #define MAKE_HEX(n) 0x##n
 #define MAKE_HEX_C(n) MAKE_HEX(n)
 
+#if defined(__AVX512F__)
+#    define SIMD_REG_SIZE 64
+#elif defined(__AVX__)
+#    define SIMD_REG_SIZE 32
+#else
+#    define SIMD_REG_SIZE 16
+#endif
+#ifdef X64
+#    define NUM_SIMD_SSE_AVX_REGS 16
+#    if defined(__AVX512F__)
+#        define NUM_SIMD_AVX512_REGS 32
+#        define NUM_SIMD_REGS NUM_SIMD_AVX512_REGS
+#        define NUM_OPMASK_REGS 8
+#        define OPMASK_REG_SIZE 2
+#    else
+#        define NUM_SIMD_REGS NUM_SIMD_SSE_AVX_REGS
+#        define NUM_OPMASK_REGS 0
+#        define OPMASK_REG_SIZE 0
+#    endif
+#else
+#    define NUM_SIMD_SSE_AVX_REGS 8
+#    if defined(__AVX512F__)
+#        define NUM_SIMD_AVX512_REGS 8
+#        define NUM_OPMASK_REGS 8
+#    endif
+#    define NUM_SIMD_REGS 8
+#    define NUM_OPMASK_REGS 0
+#    define OPMASK_REG_SIZE 0
+#endif
+
 #ifdef X64
 #    define XAX_BASE() 12345678abcdef01
 #    define XCX_BASE() 2345678abcdef012
@@ -53,40 +83,17 @@
 #    define R13_BASE() bcdef1234567890a
 #    define R14_BASE() abcdef1234567890
 #    define R15_BASE() 0abcdef123456789
+/* ?MMN is formed via ?MM0 << N. */
 #    define XMM0_LOW_BASE() 2384626433832795
 #    define XMM0_HIGH_BASE() 3141592653589793
-#    define XMM1_LOW_BASE() 1384626433832795
-#    define XMM1_HIGH_BASE() 1141592653589793
-#    define XMM2_LOW_BASE() 2384626433832795
-#    define XMM2_HIGH_BASE() 2141592653589793
-#    define XMM3_LOW_BASE() 3384626433832795
-#    define XMM3_HIGH_BASE() 3141592653589793
-#    define XMM4_LOW_BASE() 4384626433832795
-#    define XMM4_HIGH_BASE() 4141592653589793
-#    define XMM5_LOW_BASE() 5384626433832795
-#    define XMM5_HIGH_BASE() 5141592653589793
-#    define XMM6_LOW_BASE() 6384626433832795
-#    define XMM6_HIGH_BASE() 6141592653589793
-#    define XMM7_LOW_BASE() 7384626433832795
-#    define XMM7_HIGH_BASE() 7141592653589793
-#    define XMM8_LOW_BASE() 8384626433832795
-#    define XMM8_HIGH_BASE() 8141592653589793
-#    define XMM9_LOW_BASE() 9384626433832795
-#    define XMM9_HIGH_BASE() 9141592653589793
-#    define XMM10_LOW_BASE() a384626433832795
-#    define XMM10_HIGH_BASE() a141592653589793
-#    define XMM11_LOW_BASE() b384626433832795
-#    define XMM11_HIGH_BASE() b141592653589793
-#    define XMM12_LOW_BASE() c384626433832795
-#    define XMM12_HIGH_BASE() c141592653589793
-#    define XMM13_LOW_BASE() d384626433832795
-#    define XMM13_HIGH_BASE() d141592653589793
-#    define XMM14_LOW_BASE() e384626433832795
-#    define XMM14_HIGH_BASE() e141592653589793
-#    define XMM15_LOW_BASE() f384626433832795
-#    define XMM15_HIGH_BASE() f141592653589793
+#    define YMMH0_LOW_BASE() 0011223344556677
+#    define YMMH0_HIGH_BASE() 1122334455667788
+#    define ZMMH0_0_BASE() 1112223334445556
+#    define ZMMH0_1_BASE() 66777888999aaabb
+#    define ZMMH0_2_BASE() bcccdddeeefff121
+#    define ZMMH0_3_BASE() 23434565678789a9
+#    define OPMASK0_BASE() abcbcdedef0f0424
 #else
-#    error NYI
 #    define XAX_BASE() 12345678
 #    define XCX_BASE() 23456780
 #    define XDX_BASE() 34567801
@@ -94,6 +101,9 @@
 #    define XBP_BASE() 56780123
 #    define XSI_BASE() 67801234
 #    define XDI_BASE() 78012345
+/* TODO i#3160: It will take work to finish porting the detach_state test
+ * to 32-bit.
+ */
 #endif
 #define XFLAGS_BASE() 00000ed7
 
diff --git a/suite/tests/client-interface/avx512ctx-shared.h b/suite/tests/client-interface/avx512ctx-shared.h
index ca569c314d..3d1f756071 100644
--- a/suite/tests/client-interface/avx512ctx-shared.h
+++ b/suite/tests/client-interface/avx512ctx-shared.h
@@ -30,15 +30,19 @@
  * DAMAGE.
  */
 
+#ifndef _AVX512CTX_SHARED_H_
+#define _AVX512CTX_SHARED_H_ 1
+
+#ifndef __AVX512F__
+#    error "Build error, should only be added with AVX-512 support."
+#endif
+
 #define MARKER_REG REG_XAX
 #define TEST1_MARKER 0xabc6534f
 #define TEST2_MARKER 0x16dfc5a5
 
-#ifdef X64
-#    define NUM_SIMD_REGS 32
-#else
-#    define NUM_SIMD_REGS 8
-#endif
-#define NUM_OPMASK_REGS 8
+#include "../api/detach_state_shared.h" /* for NUM_{SIMD,OPMASK}_REGS */
 
 #define VERBOSE 0
+
+#endif /* _AVX512CTX_SHARED_H_ */
diff --git a/suite/tests/linux/sigcontext.c b/suite/tests/linux/sigcontext.c
index a92c5eb822..a45fc63189 100644
--- a/suite/tests/linux/sigcontext.c
+++ b/suite/tests/linux/sigcontext.c
@@ -44,23 +44,16 @@
 #include <errno.h>
 #include <stddef.h>
 
+/* For sharing NUM_*_REGS constants. */
+#include "../api/detach_state_shared.h"
+
 /* TODO i#1312: This test has been prepared for - and executes AVX-512 code, but doesn't
  * test any AVX-512 state yet.
  */
 
 #ifdef X64
-#    if defined(__AVX512F__)
-#        define NUM_SIMD_AVX512_REGS 32
-#        define NUM_OPMASK_REGS 8
-#    endif
-#    define NUM_SIMD_SSE_AVX_REGS 16
 #    define XAX "rax"
 #else
-#    if defined(__AVX512F__)
-#        define NUM_SIMD_AVX512_REGS 8
-#        define NUM_OPMASK_REGS 8
-#    endif
-#    define NUM_SIMD_SSE_AVX_REGS 8
 #    define XAX "eax"
 #endif
 #define INTS_PER_XMM 4
@@ -289,10 +282,9 @@ main(int argc, char *argv[])
         MOVE_TO_ZMM(buf, 30)
         MOVE_TO_ZMM(buf, 31)
 #        endif
-        __u32 kmaskbuf = 0x12345678;
         /* Re-using INTS_PER_ZMM here to get same data patterns as above. */
 #        define MOVE_TO_OPMASK(buf, num) \
-            __asm__ __volatile__("kmovw %0, %%k" #num : : "m"(kmaskbuf) :);
+            __asm__ __volatile__("kmovw %0, %%k" #num : : "m"(buf[num * INTS_PER_ZMM]) :);
         MOVE_TO_OPMASK(buf, 0)
         MOVE_TO_OPMASK(buf, 1)
         MOVE_TO_OPMASK(buf, 2)
@@ -328,6 +320,107 @@ main(int argc, char *argv[])
 #    endif
         /* now make sure they show up in signal context */
         kill(getpid(), SIGUSR2);
+
+        /* Ensure they are preserved across the sigreturn (xref i#3812). */
+#    ifdef __AVX512F__
+        /* Use a new buffer to avoid the old values.  We could do a custom memset
+         * with rep movs in asm instead (regular memset may clobber SIMD regs).
+         */
+        int buf2[INTS_PER_XMM * NUM_SIMD_SSE_AVX_REGS];
+#        define MOVE_FROM_ZMM(buf, num)                          \
+            __asm__ __volatile__("vmovdqu64 %%zmm" #num ", %0"   \
+                                 : "=m"(buf[num * INTS_PER_ZMM]) \
+                                 :                               \
+                                 :);
+        MOVE_FROM_ZMM(buf2, 0)
+        MOVE_FROM_ZMM(buf2, 1)
+        MOVE_FROM_ZMM(buf2, 2)
+        MOVE_FROM_ZMM(buf2, 3)
+        MOVE_FROM_ZMM(buf2, 4)
+        MOVE_FROM_ZMM(buf2, 5)
+        MOVE_FROM_ZMM(buf2, 6)
+        MOVE_FROM_ZMM(buf2, 7)
+#        ifdef X64
+        MOVE_FROM_ZMM(buf2, 8)
+        MOVE_FROM_ZMM(buf2, 9)
+        MOVE_FROM_ZMM(buf2, 10)
+        MOVE_FROM_ZMM(buf2, 11)
+        MOVE_FROM_ZMM(buf2, 12)
+        MOVE_FROM_ZMM(buf2, 13)
+        MOVE_FROM_ZMM(buf2, 14)
+        MOVE_FROM_ZMM(buf2, 15)
+        MOVE_FROM_ZMM(buf2, 16)
+        MOVE_FROM_ZMM(buf2, 17)
+        MOVE_FROM_ZMM(buf2, 18)
+        MOVE_FROM_ZMM(buf2, 19)
+        MOVE_FROM_ZMM(buf2, 20)
+        MOVE_FROM_ZMM(buf2, 21)
+        MOVE_FROM_ZMM(buf2, 22)
+        MOVE_FROM_ZMM(buf2, 23)
+        MOVE_FROM_ZMM(buf2, 24)
+        MOVE_FROM_ZMM(buf2, 25)
+        MOVE_FROM_ZMM(buf2, 26)
+        MOVE_FROM_ZMM(buf2, 27)
+        MOVE_FROM_ZMM(buf2, 28)
+        MOVE_FROM_ZMM(buf2, 29)
+        MOVE_FROM_ZMM(buf2, 30)
+        MOVE_FROM_ZMM(buf2, 31)
+#        endif
+        for (i = 0; i < NUM_SIMD_AVX512_REGS; i++) {
+            for (j = 0; j < INTS_PER_ZMM; j++) {
+                assert(buf2[i * INTS_PER_ZMM + j] == 0xdeadbeef + i * INTS_PER_ZMM + j);
+            }
+        }
+        /* Re-using INTS_PER_ZMM here to get same data patterns as above. */
+        int buf3[INTS_PER_XMM * NUM_SIMD_SSE_AVX_REGS];
+#        define MOVE_FROM_OPMASK(buf, num)                       \
+            __asm__ __volatile__("kmovw %%k" #num ", %0"         \
+                                 : "=m"(buf[num * INTS_PER_ZMM]) \
+                                 :                               \
+                                 :);
+        MOVE_FROM_OPMASK(buf3, 0)
+        MOVE_FROM_OPMASK(buf3, 1)
+        MOVE_FROM_OPMASK(buf3, 2)
+        MOVE_FROM_OPMASK(buf3, 3)
+        MOVE_FROM_OPMASK(buf3, 4)
+        MOVE_FROM_OPMASK(buf3, 5)
+        MOVE_FROM_OPMASK(buf3, 6)
+        MOVE_FROM_OPMASK(buf3, 7)
+        for (i = 0; i < NUM_OPMASK_REGS; i++) {
+            short bufval = (short)buf3[i * INTS_PER_ZMM];
+            short expect = (short)(0xdeadbeef + i * INTS_PER_ZMM);
+            assert(bufval == expect);
+        }
+#    else
+        int buf2[INTS_PER_XMM * NUM_SIMD_SSE_AVX_REGS];
+#        define MOVE_FROM_YMM(buf, num)                          \
+            __asm__ __volatile__("vmovdqu %%ymm" #num ", %0"     \
+                                 : "=m"(buf[num * INTS_PER_YMM]) \
+                                 :                               \
+                                 :);
+        MOVE_FROM_YMM(buf2, 0)
+        MOVE_FROM_YMM(buf2, 1)
+        MOVE_FROM_YMM(buf2, 2)
+        MOVE_FROM_YMM(buf2, 3)
+        MOVE_FROM_YMM(buf2, 4)
+        MOVE_FROM_YMM(buf2, 5)
+        MOVE_FROM_YMM(buf2, 6)
+        MOVE_FROM_YMM(buf2, 7)
+#        ifdef X64
+        MOVE_FROM_YMM(buf2, 8)
+        MOVE_FROM_YMM(buf2, 9)
+        MOVE_FROM_YMM(buf2, 10)
+        MOVE_FROM_YMM(buf2, 11)
+        MOVE_FROM_YMM(buf2, 12)
+        MOVE_FROM_YMM(buf2, 13)
+        MOVE_FROM_YMM(buf2, 14)
+        MOVE_FROM_YMM(buf2, 15)
+#        endif
+        for (i = 0; i < NUM_SIMD_SSE_AVX_REGS; i++) {
+            for (j = 0; j < INTS_PER_YMM; j++)
+                assert(buf2[i * INTS_PER_YMM + j] == 0xdeadbeef + i * INTS_PER_ZMM + j);
+        }
+#    endif
     }
 #endif
 
diff --git a/suite/tests/linux/sigcontext.templatex b/suite/tests/linux/sigcontext.templatex
index de517ca580..7389ffdcc9 100644
--- a/suite/tests/linux/sigcontext.templatex
+++ b/suite/tests/linux/sigcontext.templatex
@@ -59,14 +59,14 @@ ymmh\[15\] = 0xdeadbfe3 0xdeadbfe4 0xdeadbfe5 0xdeadbfe6
 #endif
 #ifdef __AVX512F__
 #ifdef X64
-kmask\[0\] = 0x5678
-kmask\[1\] = 0x5678
-kmask\[2\] = 0x5678
-kmask\[3\] = 0x5678
-kmask\[4\] = 0x5678
-kmask\[5\] = 0x5678
-kmask\[6\] = 0x5678
-kmask\[7\] = 0x5678
+kmask\[0\] = 0xbeef
+kmask\[1\] = 0xbeff
+kmask\[2\] = 0xbf0f
+kmask\[3\] = 0xbf1f
+kmask\[4\] = 0xbf2f
+kmask\[5\] = 0xbf3f
+kmask\[6\] = 0xbf4f
+kmask\[7\] = 0xbf5f
 zmm_hi256\[0\] = 0xdeadbef7 0xdeadbef8 0xdeadbef9 0xdeadbefa
 zmm_hi256\[1\] = 0xdeadbf07 0xdeadbf08 0xdeadbf09 0xdeadbf0a
 zmm_hi256\[2\] = 0xdeadbf17 0xdeadbf18 0xdeadbf19 0xdeadbf1a
